type(gen) ::=<<
package $gen.packageName$;

$if(gen.addDeprecatedAnnotation)$
import java.lang.Deprecated;
$endif$
/**
 * This is a generated class for the SObject Enterprise API.
 * Do not edit this file, as your changes will be lost.
 */
$if(gen.addDeprecatedAnnotation)$
@Deprecated
$endif$
public class $gen.className$ $gen.typeExtension$ $gen.interfaceExtension${

    /**
     * Constructor
     */
    public $gen.className$() {}
    
    /* Cache the typeInfo instead of declaring static fields throughout*/
    private transient java.util.Map<String, com.sforce.ws.bind.TypeInfo> typeInfoCache = new java.util.HashMap<String, com.sforce.ws.bind.TypeInfo>();
    private com.sforce.ws.bind.TypeInfo _lookupTypeInfo(String fieldName, String namespace, String name, String typeNS, String type, int minOcc, int maxOcc, boolean elementForm) {
      com.sforce.ws.bind.TypeInfo typeInfo = typeInfoCache.get(fieldName);
      if (typeInfo == null) {
        typeInfo = new com.sforce.ws.bind.TypeInfo(namespace, name, typeNS, type, minOcc, maxOcc, elementForm);
        typeInfoCache.put(fieldName, typeInfo);
      }
      return typeInfo;
    }

  $gen.memberMetadataList: {member |
  /**
   * element : $member.elementDoc$
   * java type: $member.javaType$
   */
  private boolean $member.fieldName$__is_set = false;

  private $member.javaType$ $member.fieldName$$member.arraySource$;

  $if(gen.generateInterfaces)$@Override$endif$
  public $member.javaType$ $member.getMethodName$() {
    return $member.fieldName$;
  \}

  $if(member.booleanJavaType)$
  $if(gen.generateInterfaces)$@Override$endif$
  public $if(gen.generateInterfaces)$$member.javaTypeInterface$$else$$member.javaType$$endif$ $member.boolMethodName$() {
    return $member.fieldName$;
  \}
$endif$

  $if(gen.generateInterfaces)$@Override$endif$
  public void $member.setMethodName$($if(gen.generateInterfaces)$$member.javaTypeInterface$$else$$member.javaType$$endif$ $member.fieldName$) {
    $if(member.isArray)$
    this.$member.fieldName$ = $if(gen.generateInterfaces)$$member.arrayCast$$else$$member.fieldName$$endif$;
    $else$
    this.$member.fieldName$ = $if(gen.generateInterfaces)$$member.castFromInterface$$endif$$member.fieldName$;
    $endif$
    $member.fieldName$__is_set = true;
  \}

  protected void $member.setMethodName$(com.sforce.ws.parser.XmlInputStream __in,
      com.sforce.ws.bind.TypeMapper __typeMapper) throws java.io.IOException, com.sforce.ws.ConnectionException {
    __in.peekTag();
    if (__typeMapper.$member.loadType$(__in, _lookupTypeInfo("$member.fieldName$", $member.typeInfo$))) {
      $member.setMethodName$($member.cast$__typeMapper.$member.loadMethod$(__in, _lookupTypeInfo("$member.fieldName$", $member.typeInfo$), $member.javaType$.class));
    \}
  \}

  private void $member.writeMethodName$(com.sforce.ws.parser.XmlOutputStream __out, com.sforce.ws.bind.TypeMapper __typeMapper) throws java.io.IOException {
    __typeMapper.writeObject(__out, _lookupTypeInfo("$member.fieldName$", $member.typeInfo$), $member.fieldName$, $member.fieldName$__is_set);
  \}

   }$    /**
     */
    @Override
    public void write(javax.xml.namespace.QName __element,
        com.sforce.ws.parser.XmlOutputStream __out, com.sforce.ws.bind.TypeMapper __typeMapper)
        throws java.io.IOException {
      __out.writeStartTag(__element.getNamespaceURI(), __element.getLocalPart());
      $gen.xsiType$
      writeFields(__out, __typeMapper);
      __out.writeEndTag(__element.getNamespaceURI(), __element.getLocalPart());
    }
   
    protected void writeFields(com.sforce.ws.parser.XmlOutputStream __out,
         com.sforce.ws.bind.TypeMapper __typeMapper)
         throws java.io.IOException {
       $gen.superWrite$
       $gen.splitMemberMetadataList: { split | writeFields$i$(__out, __typeMapper);
}$    }

    @Override
    public void load(com.sforce.ws.parser.XmlInputStream __in,
        com.sforce.ws.bind.TypeMapper __typeMapper) throws java.io.IOException, com.sforce.ws.ConnectionException {
      __typeMapper.consumeStartTag(__in);
      loadFields(__in, __typeMapper);
      __typeMapper.consumeEndTag(__in);
    \}
    
    protected void loadFields(com.sforce.ws.parser.XmlInputStream __in,
        com.sforce.ws.bind.TypeMapper __typeMapper) throws java.io.IOException, com.sforce.ws.ConnectionException {
        $gen.superLoad$
        $gen.splitMemberMetadataList: { split | loadFields$i$(__in, __typeMapper);
}$    }

    @Override
    public String toString() {
      java.lang.StringBuilder sb = new java.lang.StringBuilder();
      sb.append("[$gen.className$ ");
      $gen.superToString$
      $gen.splitMemberMetadataList: { split | toString$i$(sb);
}$
      sb.append("]\\n");
      return sb.toString();
    }

    private void toStringHelper(StringBuilder sb, String name, Object value) {
      sb.append(' ').append(name).append("='").append(com.sforce.ws.util.Verbose.toString(value)).append("'\\n");
    }

$gen.splitMemberMetadataList: { split |
    private void writeFields$i$(com.sforce.ws.parser.XmlOutputStream __out,
         com.sforce.ws.bind.TypeMapper __typeMapper) throws java.io.IOException {
      $split:{ member | $member.writeMethodName$(__out, __typeMapper);
}$    \}

    private void loadFields$i$(com.sforce.ws.parser.XmlInputStream __in,
        com.sforce.ws.bind.TypeMapper __typeMapper) throws java.io.IOException, com.sforce.ws.ConnectionException {
      $split:{ member | $member.setMethodName$(__in, __typeMapper);
}$    \}

    private void toString$i$(StringBuilder sb) {
      $split:{ member | toStringHelper(sb, "$member.fieldName$", $member.fieldName$);
}$    \}
}$
    
    $if(gen.generateInterfaces && gen.hasArrayField)$
    @SuppressWarnings("unchecked")
    private <T,U> T[] castArray(Class<T> clazz, U[] array) {
        if (array == null) {
            return null;
        }
        T[] retVal = (T[]) java.lang.reflect.Array.newInstance(clazz, array.length);
        for (int i=0; i < array.length; i++) {
            retVal[i] = (T)array[i];
        }
        	    
        return retVal;
	}
	$endif$
}

>>
